"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.job = void 0;

var _utils = require("../utils");

var _filters = require("../filters");

const job = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(onEventType(rule)).tap(_utils.printStartPipeline).map(toScanRequest(rule)).through((0, _utils.scanDynamoDB)(rule)).filter(onContent(rule)).map(toQueryRequest(rule)).through((0, _utils.queryDynamoDB)(rule)).through((0, _utils.splitObject)({
  splitTargetField: rule.queryResponseField || 'queryResponse',
  ...rule
})).map(toGetRequest(rule)).through((0, _utils.batchGetDynamoDB)(rule)).map(toUpdateRequest(rule)).through((0, _utils.updateDynamoDB)(rule)).map(toEvent(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _utils.encryptEvent)({ ...rule,
  sourceField: 'emit',
  targetField: 'emit'
})).through(rule.publish({ ...rule,
  parallel: 10,
  eventField: 'emit' // so we don't overwrite the incoming event in the uow

})).tap(_utils.printEndPipeline);

exports.job = job;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const toScanRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  scanRequest: rule.toScanRequest ? rule.toScanRequest(uow, rule) :
  /* istanbul ignore next */
  undefined
}));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toQueryRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  queryRequest: rule.toQueryRequest ?
  /* istanbul ignore next */
  rule.toQueryRequest(uow, rule) : undefined
}));

const toGetRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  batchGetRequest: rule.toGetRequest ?
  /* istanbul ignore next */
  rule.toGetRequest(uow, rule) : undefined
}));

const toUpdateRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  updateRequest: rule.toUpdateRequest ?
  /* istanbul ignore next */
  rule.toUpdateRequest(uow, rule) : undefined
}));

const toEvent = rule => (0, _utils.faultyAsyncStream)(async uow => !rule.toEvent ?
/* istanbul ignore next */
uow : { ...uow,
  emit: { ...(await (0, _utils.faultify)(rule.toEvent)(uow, rule))
  }
});