"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.materialize = void 0;

var _utils = require("../utils");

var _filters = require("../filters");

const materialize = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outSkip).filter(_filters.outSourceIsSelf).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).through((0, _utils.splitObject)(rule)).map(toUpdateRequest(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _utils.updateDynamoDB)(rule)).tap(_utils.printEndPipeline);

exports.materialize = materialize;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toUpdateRequest = rule => (0, _utils.faultyAsyncStream)(async uow => ({ ...uow,
  updateRequest: await (0, _utils.faultify)(rule.toUpdateRequest)(uow, rule)
}));