"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.materializeS3 = void 0;

var _utils = require("../utils");

var _filters = require("../filters");

const materializeS3 = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outSkip) // .filter(outSourceIsSelf)
.filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).through((0, _utils.splitObject)(rule)).map(toPutRequest(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _utils.putObjectToS3)(rule)).tap(_utils.printEndPipeline);

exports.materializeS3 = materializeS3;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toPutRequest = rule => (0, _utils.faultyAsyncStream)(async uow => ({ ...uow,
  putRequest: await (0, _utils.faultify)(rule.toPutRequest)(uow, rule)
}));