"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fromCognito = void 0;

var _highland = _interopRequireDefault(require("highland"));

var uuid = _interopRequireWildcard(require("uuid"));

var _kebabCase = _interopRequireDefault(require("lodash/kebabCase"));

var _utils = require("../utils");

/* eslint import/no-extraneous-dependencies: ["error", {"devDependencies": true}] */
const fromCognito = (event, {
  eventTypePrefix = 'aws-cognito'
} = {}) => // eslint-disable-line import/prefer-default-export
// event: https://docs.aws.amazon.com/cognito/latest/developerguide/cognito-user-identity-pools-working-with-aws-lambda-triggers.html#cognito-user-pools-lambda-trigger-event-parameter-shared
(0, _highland.default)([{
  // create a unit-of-work for the single event
  // create a stream to work with the rest of the framework
  record: event
}]).map((0, _utils.faulty)(uow => ( // create a unit-of-work for each event
// so we can correlate related work for error handling
{ ...uow,
  event: {
    id: uuid.v4(),
    type: `${eventTypePrefix}-${(0, _kebabCase.default)(uow.record.triggerSource)}`,
    partitionKey: uow.record.userName,
    tags: {
      region: uow.record.region,
      source: uow.record.userPoolId
    },
    raw: { ...uow.record.request
    }
  }
})));

exports.fromCognito = fromCognito;