"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDelay = exports.wait = exports.assertMaxRetries = exports.defaultRetryConfig = void 0;

var _bluebird = _interopRequireDefault(require("bluebird"));

const defaultRetryConfig = {
  maxRetries: Number(process.env.BATCH_MAX_RETRIES) || 8,
  retryWait: Number(process.env.BATCH_RETRY_WAIT) || 100
};
exports.defaultRetryConfig = defaultRetryConfig;

const assertMaxRetries = (attempts, maxRetries) => {
  if (attempts.length > maxRetries) {
    throw new Error(`Failed batch requests: ${JSON.stringify(attempts[attempts.length - 1])}`);
  }
};

exports.assertMaxRetries = assertMaxRetries;

const wait = ms => new _bluebird.default(r => ms ? setTimeout(r, ms) : r());

exports.wait = wait;

const getDelay = (baseMillis, attempt) => {
  if (!attempt) return 0;
  const expBackoff = 2 ** attempt;
  const finalBackoff = expBackoff + Math.round(Math.random() * baseMillis);
  return baseMillis + finalBackoff;
};

exports.getDelay = getDelay;